
/**
 * 
 * @author Lorenz Schauer
 * Aufgabe zu eigene Exceptions erstellen
 * 
 * Klasse Bruch braucht eine eigene Exception, wenn der Division durch 0 abgefangen werden soll. 
 *
 */
public class Bruch {

	// Instanzvariablen
	private double zaehler;
	private double nenner;
	
	// Leerer Konstruktor
	public Bruch(){
		
	}
	
	// Konstruktor
	public Bruch(double zaehler, double nenner){
		this.zaehler=zaehler;
		this.nenner=nenner;
	}
	
	// Methode, um den Bruch auszurechnen.
	public double berechneBruch(){
		
		// Falls der Nenner 0 ist, dann werfe die eigene Exception
		if (this.nenner==0.0)
			throw new DivisionByZeroException();
		return this.zaehler/this.nenner;
	}
	
	
	//Setter und Getter
	public double getZaehler() {
		return zaehler;
	}

	public void setZaehler(double zaehler) {
		this.zaehler = zaehler;
	}

	public double getNenner() {
		return nenner;
	}

	public void setNenner(double nenner) {
		this.nenner = nenner;
	}

	
	// Hauptprogramm: Main-Methode
	public static void main(String[] args) {
		
		// Erzeuge 2 Instanzen von Bruch
		Bruch b1 = new Bruch();
		Bruch b2 = new Bruch(3.0,0.1);
		
		// Rufe auf beiden Instanzen die berechneBruch() Methode auf und fange ggf. den Fehler ab. 
		try {
			System.out.println("Ergebnis: "+b1.berechneBruch());
		} catch (DivisionByZeroException e) {
			System.out.println(e.getMessage());
		}
		try {
			System.out.println("Ergebnis: "+b2.berechneBruch());
		} catch (DivisionByZeroException e) {
			System.out.println(e.getMessage());
		}
	}
	
}